<template>
  <div :class="['list-item', 'topic-list-item', { 'topic-list-item--stickied': topic.stickied }]">
    <div class="topic-list-item__body">
      <div class="topic-list-item__thumb" v-if="topic.imageId">
        <router-link :to="route">
          <img :src="thumb" :alt="topic.image?.caption" :title="topic.image?.caption" />
        </router-link>
      </div>
      <div class="topic-list-item__info">
        <div class="list-item-header topic-list-item__header">
          <ul class="horizontal">
            <li>
              <router-link :to="sectionRoute">{{ sectionText }}</router-link>
            </li>
            <li>
              <router-link :to="userRoute">{{ userText }}</router-link>
            </li>
            <li v-if="topic.stickied || topic.locked">
              <i v-if="topic.stickied" class="bi bi-pin-fill" data-bs-toggle="tooltip" title="Stickied"></i>
              <i v-if="topic.locked" class="bi bi-lock-fill" data-bs-toggle="tooltip" title="Locked"></i>
            </li>
          </ul>
        </div>
        <h3>
          <router-link :to="route">{{ topic.title }}</router-link>
        </h3>
        <div v-if="topic.subHeading">{{ topic.subHeading }}</div>
      </div>
      <div class="topic-list-item__user-actions" v-if="userId">
        <router-link v-if="canEditThisTopic" :to="editTopicRoute" class="btn btn-primary me-2">
          Edit
          <i class="bi bi-pencil-fill"></i>
        </router-link>
        <TopicSubscriptionButton :topic="topic" @subscribed="onSubscribed" @unsubscribed="onUnsubscribed" />
      </div>
    </div>
    <div class="list-item-footer topic-list-item__footer">
      <ul class="responsive">
        <li>
          <i class="bi bi-chat-left-text"></i>
          {{ topicPostCountText }}
        </li>
        <li>
          <i class="bi bi-clock"></i>
          <router-link :to="lastPostRoute">Last post</router-link>
          <span data-bs-toggle="tooltip" :title="lastPostCreatedTooltip">{{ lastPostCreatedText }}</span>
          <router-link :to="lastPostUserRoute">by {{ lastPostUserText }}</router-link>
        </li>
        <li>
          <i class="bi bi-eye-fill"></i>
          {{ topicViewCounterText }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import { ref, computed, onUnmounted } from 'vue'
import { useStore } from 'vuex'
import { StringHelper, useApi, useMoment } from '../../core'
import { ImageHelper } from '../../gallery'
import TopicSubscriptionButton from './topic-subscription-button.vue'

export default {
  name: 'TopicListItem',
  emits: ['subscribed', 'unsubscribed'],
  components: {
    TopicSubscriptionButton,
  },
  props: {
    topic: { type: Object, required: true },
  },
  setup(props, context) {
    const store = useStore()
    const api = useApi()
    const moment = useMoment()

    const lastPostCreatedText = ref('')
    const lastPostCreatedTooltip = ref('')
    const interval = ref(undefined)

    const thumb = computed(() => {
      return ImageHelper.getImageUrl(api.storageBaseUrl, props.topic.image, 'thumb')
    })

    const route = computed(() => {
      return props.topic ? { name: 'forum-topic', params: { alias: props.topic.alias } } : null
    })

    const sectionRoute = computed(() => {
      return props.topic.section ? { name: 'forum-section', params: { codeName: props.topic.section.codeName } } : null
    })

    const sectionText = computed(() => {
      return props.topic.section ? props.topic.section.displayName : 'Section'
    })

    const userRoute = computed(() => {
      return props.topic.user
        ? { name: 'identity-user-profile', params: { username: props.topic.user.username } }
        : null
    })

    const userText = computed(() => {
      return props.topic.user?.username || 'User'
    })

    const topicPostCountText = computed(() => {
      return StringHelper.noun(props.topic.postCount - 1 || 0, 'reply', 'replies')
    })

    const lastPostRoute = computed(() => {
      return props.topic?.lastPostId
        ? {
            name: 'forum-topic',
            params: { alias: props.topic.alias, postId: props.topic.lastPostId },
            hash: `#post${props.topic.lastPostId}`,
          }
        : null
    })

    const lastPostUserRoute = computed(() => {
      return props.topic.lastPost?.user
        ? { name: 'identity-user-profile', params: { username: props.topic.lastPost.user.username } }
        : null
    })

    const lastPostUserText = computed(() => {
      return props.topic.lastPost?.user?.username || ''
    })

    const topicViewCounterText = computed(() => {
      return StringHelper.noun(props.topic.viewCounter, 'view', 'views')
    })

    const isTopicOwner = computed(() => {
      return store.state.identity.session.userId && store.state.identity.session.userId === props.topic.userId
    })

    const canEditThisTopic = computed(() => {
      return isTopicOwner.value || store.state.identity.session.roles.includes('Moderator')
    })

    const editTopicRoute = computed(() => {
      return props.topic.alias ? { name: 'forum-topic-edit', params: { alias: props.topic.alias } } : null
    })

    const onSubscribed = (id) => {
      context.emit('subscribed', id)
    }

    const onUnsubscribed = (id) => {
      context.emit('unsubscribed', id)
    }

    const updateRelativeMomentText = () => {
      if (props.topic.lastPost) {
        const lastPostCreatedRelative = moment(props.topic.lastPost.created).fromNow()
        const lastPostCreatedAbsolute = moment(props.topic.lastPost.created).format('llll')
        const relativeDatetimes = store.state.core.persisted.relativeDatetimes
        lastPostCreatedText.value = relativeDatetimes ? lastPostCreatedRelative : lastPostCreatedAbsolute
        lastPostCreatedTooltip.value = relativeDatetimes ? lastPostCreatedAbsolute : lastPostCreatedRelative
      } else {
        lastPostCreatedText.value = ''
        lastPostCreatedTooltip.value = ''
      }
    }

    onUnmounted(() => {
      clearInterval(interval.value)
    })

    updateRelativeMomentText()
    interval.value = setInterval(function () {
      updateRelativeMomentText()
    }, 1000)

    return {
      lastPostCreatedText,
      lastPostCreatedTooltip,
      thumb,
      route,
      sectionRoute,
      sectionText,
      userRoute,
      userText,
      topicPostCountText,
      lastPostRoute,
      lastPostUserRoute,
      lastPostUserText,
      topicViewCounterText,
      isTopicOwner,
      canEditThisTopic,
      editTopicRoute,
      onSubscribed,
      onUnsubscribed,
    }
  },
}
</script>

<style lang="scss">
@use 'sass:color';
@use '../../core/sass/vars';

.topic-list-item--stickied {
  background-color: cornsilk;
  border-color: color.adjust(cornsilk, $lightness: -25%);
}

.dark .topic-list-item--stickied {
  background-color: vars.$darkPanelColor;
  border-color: vars.$darkSeparatorColor;
}

.topic-list-item__body {
  display: flex;
}

.topic-list-item__thumb {
  flex: vars.$thumbWidth 0 0;
  text-align: center;
  margin-right: vars.$spacing;

  img {
    width: 100%;
    height: auto;
  }
}

.topic-list-item__info {
  flex-grow: 1;

  h3 {
    margin-top: vars.$spacing;
    margin: 0;
  }
}

.topic-list-item__user-actions {
  display: none;

  // Only show the subscribe button in the list on larger devices.
  // The user will have to view the topic page on smaller devices.
  @media only screen and (min-width: vars.$md) {
    flex-grow: 0;
    display: block;
    text-align: right;
    white-space: nowrap;
  }
}

.topic-list-item__header {
  color: vars.$subtextColor;

  i:not(:last-of-type) {
    margin-right: vars.$iconSpacing;
  }
}

.dark .topic-list-item__header {
  color: vars.$darkSubtextColor;
}

.topic-list-item__footer {
  color: vars.$subtextColor;
  font-size: vars.$subtextFontSize;
}

.dark .topic-list-item__footer {
  color: vars.$darkSubtextColor;
}

.topic-list-item__header a,
.topic-list-item__footer a {
  color: vars.$subtextColor;
}

.dark {
  .topic-list-item__header a,
  .topic-list-item__footer a {
    color: vars.$darkSubtextColor;
  }
}

.topic-list-item__footer a,
.topic-list-item__footer span {
  margin-left: vars.$iconSpacing;
}
</style>
